// H to Pas Converter Ver0.4.0.4
//     Date : 97/09/02
//   Source : spssdio.h

unit spssdio;

{$P+}

interface

uses Windows;
const
/****************************************** VARIABLE TYPES
*/
//#define    SPSS_STRING(length)        (length)
   SPSS_NUMERIC            =   0

/****************************************** MISSING VALUE TYPE CODES
*/
//long
   SPSS_NO_MISSVAL         =   0
   SPSS_ONE_MISSVAL        =   1
   SPSS_TWO_MISSVAL        =   2
   SPSS_THREE_MISSVAL      =   3
   SPSS_MISS_RANGE         =  -2
   SPSS_MISS_RANGEANDVAL   =  -3

/****************************************** ERROR CODES
*/
   SPSS_OK                 =   0

   SPSS_FILE_OERROR        =   1
   SPSS_FILE_WERROR        =   2
   SPSS_FILE_RERROR        =   3
   SPSS_FITAB_FULL         =   4
   SPSS_INVALID_HANDLE     =   5
   SPSS_INVALID_FILE       =   6
   SPSS_NO_MEMORY          =   7

   SPSS_OPEN_RDMODE        =   8
   SPSS_OPEN_WRMODE        =   9

   SPSS_INVALID_VARNAME    =   10
   SPSS_DICT_EMPTY         =   11
   SPSS_VAR_NOTFOUND       =   12
   SPSS_DUP_VAR            =   13
   SPSS_NUME_EXP           =   14
   SPSS_STR_EXP            =   15
   SPSS_SHORTSTR_EXP       =   16
   SPSS_INVALID_VARTYPE    =   17

   SPSS_INVALID_MISSFOR    =   18
   SPSS_INVALID_COMPSW     =   19
   SPSS_INVALID_PRFOR      =   20
   SPSS_INVALID_WRFOR      =   21
   SPSS_INVALID_DATE       =   22
   SPSS_INVALID_TIME       =   23

   SPSS_NO_VARIABLES       =   24
   SPSS_DUP_VALUE          =   27

   SPSS_INVALID_CASEWGT    =   28
   SPSS_DICT_COMMIT        =   30
   SPSS_DICT_NOTCOMMIT     =   31

   SPSS_NO_TYPE2           =   33
   SPSS_NO_TYPE73          =   41
   SPSS_INVALID_DATEINFO   =   45
   SPSS_NO_TYPE999         =   46
   SPSS_EXC_STRVALUE       =   47
   SPSS_CANNOT_FREE        =   48
   SPSS_BUFFER_SHORT       =   49
   SPSS_INVALID_CASE       =   50
   SPSS_INTERNAL_VLABS     =   51
   SPSS_INCOMPAT_APPEND    =   52
   SPSS_INTERNAL_D_A       =   53


/****************************************** WARNING CODES
*/
   SPSS_EXC_LEN64          =  -1
   SPSS_EXC_LEN120         =  -2     /* Retain for compatibility */
   SPSS_EXC_VARLABEL       =  -2
   SPSS_EXC_LEN60          =  -4     /* Retain for compatibility */
   SPSS_EXC_VALLABEL       =  -4
   SPSS_FILE_END           =  -5
   SPSS_NO_VARSETS         =  -6
   SPSS_EMPTY_VARSETS      =  -7
   SPSS_NO_LABELS          =  -8
   SPSS_NO_LABEL           =  -9
   SPSS_NO_CASEWGT         = -10
   SPSS_NO_DATEINFO        = -11

/****************************************** FORMAT TYPE CODES
*/
// long
  SPSS_FMT_A         =   1    /* Alphanumeric */
  SPSS_FMT_AHEX      =   2    /* Alphanumeric hexadecimal */
  SPSS_FMT_COMMA     =   3    /* F Format with commas */
  SPSS_FMT_DOLLAR    =   4    /* Commas and floating dollar sign */
  SPSS_FMT_F         =   5    /* Default Numeric Format */
  SPSS_FMT_IB        =   6    /* Integer binary */
  SPSS_FMT_PIBHEX    =   7    /* Positive integer binary - hex */
  SPSS_FMT_P         =   8    /* Packed decimal */
  SPSS_FMT_PIB       =   9    /* Positive integer binary unsigned */
  SPSS_FMT_PK        =  10    /* Positive integer binary unsigned */
  SPSS_FMT_RB        =  11    /* Floating point binary */
  SPSS_FMT_RBHEX     =  12    /* Floating point binary hex */
  SPSS_FMT_Z         =  15    /* Zoned decimal */
  SPSS_FMT_N         =  16    /* N Format- unsigned with leading 0s */
  SPSS_FMT_E         =  17    /* E Format- with explicit power of 10 */
  SPSS_FMT_DATE      =  20    /* Date format dd-mmm-yyyy */
  SPSS_FMT_TIME      =  21    /* Time format hh:mm:ss.s  */
  SPSS_FMT_DATE_TIME =  22    /* Date and Time           */
  SPSS_FMT_ADATE     =  23    /* Date format dd-mmm-yyyy */
  SPSS_FMT_JDATE     =  24    /* Julian date - yyyyddd   */
  SPSS_FMT_DTIME     =  25    /* Date-time dd hh:mm:ss.s */
  SPSS_FMT_WKDAY     =  26    /* Day of the week         */
  SPSS_FMT_MONTH     =  27    /* Month                   */
  SPSS_FMT_MOYR      =  28    /* mmm yyyy                */
  SPSS_FMT_QYR       =  29    /* q Q yyyy                */
  SPSS_FMT_WKYR      =  30    /* ww WK yyyy              */
  SPSS_FMT_PCT       =  31    /* Percent - F followed by % */
  SPSS_FMT_DOT       =  32    /* Like COMMA, switching dot for comma */
  SPSS_FMT_CCA       =  33    /* User Programmable currency format   */
  SPSS_FMT_CCB       =  34    /* User Programmable currency format   */
  SPSS_FMT_CCC       =  35    /* User Programmable currency format   */
  SPSS_FMT_CCD       =  36    /* User Programmable currency format   */
  SPSS_FMT_CCE       =  37    /* User Programmable currency format   */
  SPSS_FMT_EDATE     =  38    /* Date in dd/mm/yyyy style            */
  SPSS_FMT_SDATE     =  39    /* Date in yyyy/mm/dd style            */

/****************************************** MAXIMUM LENGTHS OF DATA FILE OBJECTS
*/
  SPSS_MAX_VARNAME   =   8     /* Variable name */
  SPSS_MAX_SHORTSTRING=  8     /* Short string variable */
   SPSS_MAX_IDSTRING  =  64     /* File label string */
   SPSS_MAX_LONGSTRING= 255     /* Long string variable */
   SPSS_MAX_VALLABEL  =  60     /* Value label */
   SPSS_MAX_VARLABEL  = 256     /* Variable label */

/****************************************** API FUNCTIONS

// H to Pas Converter Ver0.4.0.4
//     Date : 97/09/02
//   Source : spssdioc.h


  function spssSysmisVal: __stdcall;

  function spssLowHighVal(var lowest: double; var highest: double): __stdcall;

  function spssOpenWrite(const fileName: Pchar; var handle: Integer): __stdcall;

  function spssSetIdString(const handle: Integer; const id: Pchar): __stdcall;

  function spssSetCompression(const handle: Integer; const compSwitch: Integer): __stdcall;

  function spssSetVarName(const handle: Integer; const varName: Pchar; const varType: Integer): __stdcall;

  function spssSetVarLabel(const handle: Integer; const varName: Pchar; const varLabel: Pchar): __stdcall;

  function spssSetVarPrintFormat(const handle: Integer; const varName: Pchar; const printType: Integer; 
	 const printDec: Integer; const printWidth: Integer): __stdcall;


  function spssSetVarWriteFormat(const handle: Integer; const varName: Pchar; const writeType: Integer; 
	 const writeDec: Integer; const writeWidth: Integer): __stdcall;

  function spssSetVarNMissingValues(const handle: Integer; const varName: Pchar; 
	 const missingFormat: Integer; const missingVal1: double; const missingVal2: double; 
	 const missingVal3: double): __stdcall;

  function spssSetVarCMissingValues(const handle: Integer; const varName: Pchar; 
	 const missingFormat: Integer; const missingVal1: Pchar; const missingVal2: Pchar; 
	 const missingVal3: Pchar): __stdcall;

  function spssSetVarNValueLabel(const handle: Integer; const varName: Pchar; const value: double; 
	 const label: Pchar): __stdcall;

  function spssSetVarCValueLabel(const handle: Integer; const varName: Pchar; const value: Pchar; 
	 const label: Pchar): __stdcall;

  function spssSetVarNValueLabels(const handle: Integer; const *varNames: Pchar; 
	 const numofVars: Integer; const values: LPdouble; const *labels: Pchar; const numofLabels: Integer): __stdcall;

  function spssSetVarCValueLabels(const handle: Integer; const *varNames: Pchar; 
	 const numofVars: Integer; const *values: Pchar; const *labels: Pchar; const numofLabels: Integer): __stdcall;

  function spssSetVariableSets(const handle: Integer; const varSets: Pchar): __stdcall;

  function spssSetDateVariables(const handle: Integer; const numofElements: Integer; 
	 const dateInfo: LPLongInt): __stdcall;

  function spssSetCaseWeightVar(const handle: Integer; const varName: Pchar): __stdcall;

  function spssCommitHeader(const handle: Integer): __stdcall;

  function spssGetVarHandle(const handle: Integer; const varName: Pchar; var varHandle: double): __stdcall;

  function spssConvertDate(const day: Integer; const month: Integer; const year: Integer; 
	 var spssDate: double): __stdcall;

  function spssConvertTime(const day: LongInt; const hour: Integer; const minute: Integer; 
	 const second: double; var spssTime: double): __stdcall;

  function spssSetValueNumeric(const handle: Integer; const varHandle: double; const value: double): __stdcall;

  function spssSetValueChar(const handle: Integer; const varHandle: double; const value: Pchar): __stdcall;

  function spssCommitCaseRecord(const handle: Integer): __stdcall;

  function spssWholeCaseOut(const handle: Integer; const caseRec: Pointer): __stdcall;

  function spssCloseWrite(const handle: Integer): __stdcall;

  function spssOpenRead(const fileName: Pchar; var handle: Integer): __stdcall;

  function spssGetIdString(const handle: Integer; var id: char): __stdcall;

  function spssGetNumberofCases(const handle: Integer; var caseCount: LongInt): __stdcall;

  function spssGetNumberofVariables(const handle: Integer; var numVars: Integer): __stdcall;

  function spssGetCompression(const handle: Integer; var compSwitch: Integer): __stdcall;

  function spssGetCaseWeightVar(const handle: Integer; var varName: char): __stdcall;



// Error :   function spssGetVarNames(const handle: Integer; var numVars: Integer;  * *varNames , Integer **varTypes ) ;

  function spssGetVarInfo(const handle: Integer; iVar: Integer; var varName: char; 
	 var varType: Integer): __stdcall;

  function spssGetVarLabel(const handle: Integer; const varName: Pchar; var varLabel: char): __stdcall;

  function spssGetVarPrintFormat(const handle: Integer; const varName: Pchar; var printType: Integer; 
	 var printDec: Integer; var printWidth: Integer): __stdcall;

  function spssGetVarWriteFormat(const handle: Integer; const varName: Pchar; var writeType: Integer; 
	 var writeDec: Integer; var writeWidth: Integer): __stdcall;

  function spssGetVarNMissingValues(const handle: Integer; const varName: Pchar; 
	 var missingFormat: Integer; var missingVal1: double; var missingVal2: double; var missingVal3: double): __stdcall;

  function spssGetVarCMissingValues(const handle: Integer; const varName: Pchar; 
	 var missingFormat: Integer; var missingVal1: char; var missingVal2: char; var missingVal3: char): __stdcall;

  function spssGetVarNValueLabel(const handle: Integer; const varName: Pchar; const value: double; 
	 var label: char): __stdcall;

  function spssGetVarCValueLabel(const handle: Integer; const varName: Pchar; const value: Pchar; 
	 var label: char): __stdcall;

  function spssGetVarNValueLabels(const handle: Integer; const varName: Pchar; var *values: double; 
// Error : 	  * *labels , Integer *numofLabels ) ;

// Error :   function spssGetVarCValueLabels(const handle: Integer; const varName: Pchar;  * *values , char ** *labels , Integer *numofLabels ) ;

  function spssGetReleaseInfo(handle: Integer; relInfo[]: Integer): __stdcall;

  function spssGetVariableSets(const handle: Integer; var *varSets: char): __stdcall;

  function spssGetDateVariables(const handle: Integer; var numofElements: Integer; 
	 var *dateInfo: LongInt): __stdcall;

  function spssGetCaseSize(const handle: Integer; var caseSize: LongInt): __stdcall;

  function spssConvertSPSSDate(var day: Integer; var month: Integer; var year: Integer; 
	 const spssDate: double): __stdcall;

  function spssConvertSPSSTime(var day: LongInt; var hourh: Integer; var minute: Integer; 
	 var second: double; const spssDate: double): __stdcall;


  function spssGetValueNumeric(const handle: Integer; const varHandle: double; var value: double): __stdcall;

  function spssGetValueChar(const handle: Integer; const varHandle: double; var value: char; 
	 valueSize: Integer): __stdcall;

  function spssReadCaseRecord(const handle: Integer): __stdcall;

  function spssWholeCaseIn(const handle: Integer; caseRec: Pointer): __stdcall;

  function spssCloseRead(const handle: Integer): __stdcall;

  function spssFreeVarNames(var *varNames: char; var varTypes: Integer; numVars: Integer): __stdcall;

// Error :   function spssFreeVarCValueLabels( * values , char ** labels , Integer numLabels ) ;

// Error :   function spssFreeVarNValueLabels(var values: double;  * labels , Integer numLabels ) ;

  function spssOpenAppend(const fileName: Pchar; var handle: Integer): __stdcall;

  function spssCloseAppend(const handle: Integer): __stdcall;

  function spssGetSystemString(const handle: Integer; var sysName: char): __stdcall;

  function spssGetTimeStamp(const handle: Integer; var fileDate: char; var fileTime: char): __stdcall;

  function spssGetVarLabelLong(const handle: Integer; const varName: Pchar; var labelBuff: char; 
	 const lenBuff: Integer; var lenLabel: Integer): __stdcall;

  function spssGetVarNValueLabelLong(const handle: Integer; const varName: Pchar; 
	 const value: double; var labelBuff: char; const lenBuff: Integer; var lenLabel: Integer): __stdcall;

  function spssGetVarCValueLabelLong(const handle: Integer; const varName: Pchar; 
	 const value: Pchar; var labelBuff: char; const lenBuff: Integer; var lenLabel: Integer): __stdcall;

  function spssSeekNextCase(const handle: Integer; const caseNumber: LongInt): __stdcall;

  function spssGetEstimatedNofCases(const handle: Integer; var caseCount: LongInt): __stdcall;

  function spssFreeVariableSets(var varSets: char): __stdcall;

  function spssFreeDateVariables(var dateInfo: LongInt): __stdcall;

implementation

end.
