// H to Pas Converter Ver0.4.0.4
//     Date : 97/09/02
//   Source : spssdio.h

unit spssdio1;

{$P+}

interface

uses Windows, Dialogs;
const
//****************************************** VARIABLE TYPES
//#SPSS_STRING(length)        (length)
   SPSS_NUMERIC            =   0 ;

//****************************************** MISSING VALUE TYPE CODES

//long
   SPSS_NO_MISSVAL         =   0 ;
   SPSS_ONE_MISSVAL        =   1 ;
   SPSS_TWO_MISSVAL        =   2 ;
   SPSS_THREE_MISSVAL      =   3 ;
   SPSS_MISS_RANGE         =  -2 ;
   SPSS_MISS_RANGEANDVAL   =  -3 ;

//****************************************** ERROR CODES

   SPSS_OK                 =   0 ;

   SPSS_FILE_OERROR        =   1 ;
   SPSS_FILE_WERROR        =   2 ;
   SPSS_FILE_RERROR        =   3 ;
   SPSS_FITAB_FULL         =   4 ;
   SPSS_INVALID_HANDLE     =   5 ;
   SPSS_INVALID_FILE       =   6 ;
   SPSS_NO_MEMORY          =   7 ;

   SPSS_OPEN_RDMODE        =   8 ;
   SPSS_OPEN_WRMODE        =   9 ;

   SPSS_INVALID_VARNAME    =   10 ;
   SPSS_DICT_EMPTY         =   11 ;
   SPSS_VAR_NOTFOUND       =   12 ;
   SPSS_DUP_VAR            =   13 ;
   SPSS_NUME_EXP           =   14 ;
   SPSS_STR_EXP            =   15 ;
   SPSS_SHORTSTR_EXP       =   16 ;
   SPSS_INVALID_VARTYPE    =   17 ;

   SPSS_INVALID_MISSFOR    =   18 ;
   SPSS_INVALID_COMPSW     =   19 ;
   SPSS_INVALID_PRFOR      =   20 ;
   SPSS_INVALID_WRFOR      =   21 ;
   SPSS_INVALID_DATE       =   22 ;
   SPSS_INVALID_TIME       =   23 ;

   SPSS_NO_VARIABLES       =   24 ;
   SPSS_DUP_VALUE          =   27 ;

   SPSS_INVALID_CASEWGT    =   28 ;
   SPSS_DICT_COMMIT        =   30 ;
   SPSS_DICT_NOTCOMMIT     =   31 ;

   SPSS_NO_TYPE2           =   33 ;
   SPSS_NO_TYPE73          =   41 ;
   SPSS_INVALID_DATEINFO   =   45 ;
   SPSS_NO_TYPE999         =   46 ;
   SPSS_EXC_STRVALUE       =   47 ;
   SPSS_CANNOT_FREE        =   48 ;
   SPSS_BUFFER_SHORT       =   49 ;
   SPSS_INVALID_CASE       =   50 ;
   SPSS_INTERNAL_VLABS     =   51 ;
   SPSS_INCOMPAT_APPEND    =   52 ;
   SPSS_INTERNAL_D_A       =   53 ;


//****************************************** WARNING CODES

   SPSS_EXC_LEN64          =  -1 ;
   SPSS_EXC_LEN120         =  -2 ;    // Retain for compatibility */
   SPSS_EXC_VARLABEL       =  -2 ;
   SPSS_EXC_LEN60          =  -4 ;    // Retain for compatibility */
   SPSS_EXC_VALLABEL       =  -4 ;
   SPSS_FILE_END           =  -5 ;
   SPSS_NO_VARSETS         =  -6 ;
   SPSS_EMPTY_VARSETS      =  -7 ;
   SPSS_NO_LABELS          =  -8 ;
   SPSS_NO_LABEL           =  -9 ;
   SPSS_NO_CASEWGT         = -10 ;
   SPSS_NO_DATEINFO        = -11 ;

//****************************************** FORMAT TYPE CODES

// long
  SPSS_FMT_A         =   1 ;   // Alphanumeric */
  SPSS_FMT_AHEX      =   2 ;   // Alphanumeric hexadecimal */
  SPSS_FMT_COMMA     =   3 ;   // F Format with commas */
  SPSS_FMT_DOLLAR    =   4 ;   // Commas and floating dollar sign */
  SPSS_FMT_F         =   5 ;   // Default Numeric Format */
  SPSS_FMT_IB        =   6 ;   // Integer binary */
  SPSS_FMT_PIBHEX    =   7 ;   // Positive integer binary - hex */
  SPSS_FMT_P         =   8 ;   // Packed decimal */
  SPSS_FMT_PIB       =   9 ;   // Positive integer binary unsigned */
  SPSS_FMT_PK        =  10 ;   // Positive integer binary unsigned */
  SPSS_FMT_RB        =  11 ;   // Floating point binary */
  SPSS_FMT_RBHEX     =  12 ;   // Floating point binary hex */
  SPSS_FMT_Z         =  15 ;   // Zoned decimal */
  SPSS_FMT_N         =  16 ;   // N Format- unsigned with leading 0s */
  SPSS_FMT_E         =  17 ;   // E Format- with explicit power of 10 */
  SPSS_FMT_DATE      =  20 ;   // Date format dd-mmm-yyyy */
  SPSS_FMT_TIME      =  21 ;   // Time format hh:mm:ss.s  */
  SPSS_FMT_DATE_TIME =  22 ;   // Date and Time           */
  SPSS_FMT_ADATE     =  23 ;   // Date format dd-mmm-yyyy */
  SPSS_FMT_JDATE     =  24 ;   // Julian date - yyyyddd   */
  SPSS_FMT_DTIME     =  25 ;   // Date-time dd hh:mm:ss.s */
  SPSS_FMT_WKDAY     =  26 ;   // Day of the week         */
  SPSS_FMT_MONTH     =  27 ;   // Month                   */
  SPSS_FMT_MOYR      =  28 ;   // mmm yyyy                */
  SPSS_FMT_QYR       =  29 ;   // q Q yyyy                */
  SPSS_FMT_WKYR      =  30 ;   // ww WK yyyy              */
  SPSS_FMT_PCT       =  31 ;   // Percent - F followed by % */
  SPSS_FMT_DOT       =  32 ;   // Like COMMA, switching dot for comma */
  SPSS_FMT_CCA       =  33 ;   // User Programmable currency format   */
  SPSS_FMT_CCB       =  34 ;   // User Programmable currency format   */
  SPSS_FMT_CCC       =  35 ;   // User Programmable currency format   */
  SPSS_FMT_CCD       =  36 ;   // User Programmable currency format   */
  SPSS_FMT_CCE       =  37 ;   // User Programmable currency format   */
  SPSS_FMT_EDATE     =  38 ;   // Date in dd/mm/yyyy style            */
  SPSS_FMT_SDATE     =  39 ;   // Date in yyyy/mm/dd style            */

//************************************ MAXIMUM LENGTHS OF DATA FILE OBJECTS

  SPSS_MAX_VARNAME   =   8 ;    // Variable name */
  SPSS_MAX_SHORTSTRING=  8 ;    // Short string variable */
   SPSS_MAX_IDSTRING  =  64;     // File label string */
   SPSS_MAX_LONGSTRING= 255;     // Long string variable */
   SPSS_MAX_VALLABEL  =  60;     // Value label */
   SPSS_MAX_VARLABEL  = 256;     // Variable label */

//****************************************** API FUNCTIONS

// H to Pas Converter Ver0.4.0.4
//     Date : 97/09/02
//   Source : spssdioc.h

const   MaxNumValLabels = 100;


type idtype= array[0..(SPSS_MAX_IDSTRING+1)] of char;
type vartype= array[0..(SPSS_MAX_VARNAME +1)] of char;
type varLabeltype= array[0..121] of char;
type valueLabeltype = array[0..(SPSS_MAX_VALLABEL+1)] of char;
type charValuetype = array[0..255] of char;
type
  TValues = array [0..MaxNumValLabels - 1] of Double;
  PValues = ^TValues;
  TLabels = array [0..MaxNumValLabels - 1] of PChar;
  PLabels = ^TLabels;

//function̈ꕔ`FbNĂȂBsetnno check
function spssGetVarNValueLabels(handle: Integer; varname: PChar;
  var values: PValues; var labels: PLabels; var numofLabels: integer):
  integer; stdcall; external 'spssio32.dll' name 'spssGetVarNValueLabels@20';


function spssFreeVarNValueLabels(values: double;labels:pchar;
     numLabels:Integer  ) :integer;   stdcall; external 'spssio32.dll' name 'spssFreeVarNValueLabels@12';    // Error :



  function spssSysmisVal:double; stdcall;external 'spssio32.dll' name 'spssSysmisVal@0';

  procedure spssLowHighVal(var lowest: double; var highest: double)  stdcall;external  'spssio32.dll' name 'spssLowHighVal@8';

  function spssOpenWrite(const fileName: Pchar; var handle: Integer):integer;   stdcall; external 'spssio32.dll' name 'spssOpenWrite@8';

  function spssSetIdString(const handle: Integer; const id: Pchar):integer;   stdcall; external 'spssio32.dll' name 'spssSetIdString@8';

  function spssSetCompression(const handle: Integer; const compSwitch: Integer):integer;   stdcall; external 'spssio32.dll' name 'spssSetCompression@8';

  function spssSetVarName(const handle: Integer; const varName: Pchar; const varType: Integer):integer;   stdcall; external 'spssio32.dll' name 'spssSetVarName@12';

  function spssSetVarLabel(const handle: Integer; const varName: Pchar; const varLabel: Pchar):integer;   stdcall; external 'spssio32.dll' name 'spssSetVarLabel@12';

  function spssSetVarPrintFormat(const handle: Integer; const varName: Pchar; const printType: Integer; 
	 const printDec: Integer; const printWidth: Integer):integer;   stdcall; external 'spssio32.dll' name 'spssSetVarPrintFormat@20';


  function spssSetVarWriteFormat(const handle: Integer; const varName: Pchar; const writeType: Integer; 
	 const writeDec: Integer; const writeWidth: Integer):integer;   stdcall; external 'spssio32.dll' name 'spssSetVarWriteFormat@20';

  function spssSetVarNMissingValues(const handle: Integer; const varName: Pchar;
	 const missingFormat: Integer; const missingVal1: double; const missingVal2: double;
	 const missingVal3: double):integer;   stdcall; external 'spssio32.dll' name 'spssSetVarNMissingValues@36';

  function spssSetVarCMissingValues(const handle: Integer; const varName: Pchar; 
	 const missingFormat: Integer; const missingVal1: Pchar; const missingVal2: Pchar; 
	 const missingVal3: Pchar):integer;   stdcall; external 'spssio32.dll' name 'spssSetVarCMissingValues@24';

  function spssSetVarNValueLabel(const handle: Integer; const varName: Pchar; const value: double;
	 const labelx: Pchar):integer;   stdcall; external 'spssio32.dll' name 'spssSetVarNValueLabel@20';

  function spssSetVarCValueLabel(const handle: Integer; const varName: Pchar; const value: Pchar; 
	 const labelx: Pchar):integer;   stdcall; external 'spssio32.dll' name 'spssSetVarCValueLabel@16';

  function spssSetVarNValueLabels(const handle: Integer; const varnames: Pchar;
	 const numofVars: Integer; const values: double; const labels: Pchar; const numofLabels: Integer):integer;   stdcall; external 'spssio32.dll' name 'spssSetVarNValueLabels@24';

  function spssSetVarCValueLabels(const handle: Integer; const varnames: Pchar;
	 const numofVars: Integer; const values: Pchar; const labels: Pchar; const numofLabels: Integer):integer;   stdcall; external 'spssio32.dll' name 'spssSetVarCValueLabels@20';

  function spssSetVariableSets(const handle: Integer; const varSets: Pchar):integer;   stdcall; external 'spssio32.dll' name 'spssSetVariableSets@8'; 

  function spssSetDateVariables(const handle: Integer; const numofElements: Integer;
	 const dateInfo: LongInt):integer;   stdcall; external 'spssio32.dll' name 'spssSetDateVariables@12';

  function spssSetCaseWeightVar(const handle: Integer; const varname: Pchar):integer;   stdcall; external 'spssio32.dll' name 'spssSetCaseWeightVar@8'; 

  function spssCommitHeader(const handle: Integer):integer;   stdcall; external 'spssio32.dll' name 'spssCommitHeader@4'; 

  function spssGetVarHandle(const handle: Integer; const varname: Pchar; var varHandle: double):integer;   stdcall; external 'spssio32.dll' name 'spssGetVarHandle@12'; 

  function spssConvertDate(const day: Integer; const month: Integer; const year: Integer; 
	 var spssDate: double):integer;   stdcall; external 'spssio32.dll' name 'spssConvertDate@16'; 

  function spssConvertTime(const day: LongInt; const hour: Integer; const minute: Integer; 
	 const second: double; var spssTime: double):integer;   stdcall; external 'spssio32.dll' name 'spssConvertTime@24'; 

  function spssSetValueNumeric(const handle: Integer; const varHandle: double; const value: double):integer;   stdcall; external 'spssio32.dll' name 'spssSetValueNumeric@20'; 

  function spssSetValueChar(const handle: Integer; const varHandle: double; const value: Pchar):integer;   stdcall; external 'spssio32.dll' name 'spssSetValueChar@16'; 

  function spssCommitCaseRecord(const handle: Integer):integer;   stdcall; external 'spssio32.dll' name 'spssCommitCaseRecord@4'; 

  function spssWholeCaseOut(const handle: Integer; const caseRec: Pointer):integer;   stdcall; external 'spssio32.dll' name 'spssWholeCaseOut@8'; 

  function spssCloseWrite(const handle: Integer):integer;   stdcall; external 'spssio32.dll' name 'spssCloseWrite@4'; 

  function spssOpenRead(const filename : Pchar; var handle: Integer):integer;   stdcall; external 'spssio32.dll' name 'spssOpenRead@8';

  function spssGetIdString(const handle: Integer;var id:idtype) :integer;   stdcall; external 'spssio32.dll' name 'spssGetIdString@8';

  function spssGetNumberofCases(const handle: Integer; var caseCount: LongInt):integer;   stdcall; external 'spssio32.dll' name 'spssGetNumberofCases@8';

  function spssGetNumberofVariables(const handle: Integer; var numVars: Integer):integer;   stdcall; external 'spssio32.dll' name 'spssGetNumberofVariables@8'; 

  function spssGetCompression(const handle: Integer; var compSwitch: Integer):integer;   stdcall; external 'spssio32.dll' name 'spssGetCompression@8'; 

  function spssGetCaseWeightVar(const handle: Integer; var varname : vartype):integer;   stdcall; external 'spssio32.dll' name 'spssGetCaseWeightVar@8';



//  function spssGetVarNames(const handle: Integer; var numVars: Integer;  * *varNames:pchar;, Integer **var varTypes:integer ):integer;   stdcall; external 'spssio32.dll' name 'spssGetVarNames@16';    // Error :

  function spssGetVarInfo(const handle: Integer; iVar: Integer; var varname : vartype;
	 var varType: Integer):integer;   stdcall; external 'spssio32.dll' name 'spssGetVarInfo@16'; 

  function spssGetVarLabel(const handle: Integer; const varname : Pchar; var varLabel: varLabeltype):integer;   stdcall; external 'spssio32.dll' name 'spssGetVarLabel@12';

  function spssGetVarPrintFormat(const handle: Integer; const varname : Pchar; var printType: Integer; 
	 var printDec: Integer; var printWidth: Integer):integer;   stdcall; external 'spssio32.dll' name 'spssGetVarPrintFormat@20'; 

  function spssGetVarWriteFormat(const handle: Integer; const varname : Pchar; var writeType: Integer; 
	 var writeDec: Integer; var writeWidth: Integer):integer;   stdcall; external 'spssio32.dll' name 'spssGetVarWriteFormat@20'; 

  function spssGetVarNMissingValues(const handle: Integer; const varname : Pchar; 
	 var missingFormat: Integer; var missingVal1: double; var missingVal2: double;
         var missingVal3: double):integer;   stdcall; external 'spssio32.dll' name 'spssGetVarNMissingValues@24';

  function spssGetVarCMissingValues(const handle: Integer; const varname : Pchar; 
	 var missingFormat: Integer; var missingVal1: char; var missingVal2: char; var missingVal3: char):integer;   stdcall; external 'spssio32.dll' name 'spssGetVarCMissingValues@24'; 

  function spssGetVarNValueLabel(const handle: Integer; const varname : Pchar; const value: double; 
	 var labelx: valueLabeltype):integer;   stdcall; external 'spssio32.dll' name 'spssGetVarNValueLabel@20';

  function spssGetVarCValueLabel(const handle: Integer; const varname : Pchar; const value: Pchar; 
	 var labelx: valueLabeltype):integer;   stdcall; external 'spssio32.dll' name 'spssGetVarCValueLabel@16';

//  function spssGetVarNValueLabels(const handle: Integer; const varname : Pchar; var *values: double; 
//  * *labels:pchar ,  var numofLabels:Integer ) :integer;   stdcall; external 'spssio32.dll' name 'spssGetVarNValueLabels@20';    // Error :

//   function spssGetVarCValueLabels(const handle: Integer; const varname : Pchar;  * *values:pchar;  ** *labels:pchar; var numofLabels:integer ):integer;   stdcall; external 'spssio32.dll' name 'spssGetVarCValueLabels@20';     // Error :

  function spssGetReleaseInfo(handle: Integer; relInfo: Integer):integer;   stdcall; external 'spssio32.dll' name 'spssGetReleaseInfo@8';  //??

  function spssGetVariableSets(const handle: Integer; var varSets: char):integer;   stdcall; external 'spssio32.dll' name 'spssGetVariableSets@8';

  function spssGetDateVariables(const handle: Integer; var numofElements: Integer; 
	 var dateInfo: LongInt):integer;   stdcall; external 'spssio32.dll' name 'spssGetDateVariables@12';

  function spssGetCaseSize(const handle: Integer; var caseSize: LongInt):integer;   stdcall; external 'spssio32.dll' name 'spssGetCaseSize@8'; 

  function spssConvertSPSSDate(var day: Integer; var month: Integer; var year: Integer; 
	 const spssDate: double):integer;   stdcall; external 'spssio32.dll' name 'spssConvertSPSSDate@20'; 

  function spssConvertSPSSTime(var day: LongInt; var hourh: Integer; var minute: Integer; 
	 var second: double; const spssDate: double):integer;   stdcall; external 'spssio32.dll' name 'spssConvertSPSSTime@24'; 


  function spssGetValueNumeric(const handle: Integer; const varHandle: double; var value: double):integer;   stdcall; external 'spssio32.dll' name 'spssGetValueNumeric@16'; 

  function spssGetValueChar(const handle: Integer; const varHandle: double; var value: charValuetype;
	 valueSize: Integer):integer;   stdcall; external 'spssio32.dll' name 'spssGetValueChar@20'; 

  function spssReadCaseRecord(const handle: Integer):integer;   stdcall; external 'spssio32.dll' name 'spssReadCaseRecord@4'; 

  function spssWholeCaseIn(const handle: Integer; caseRec: Pointer):integer;   stdcall; external 'spssio32.dll' name 'spssWholeCaseIn@8'; 

  function spssCloseRead(const handle: Integer):integer;   stdcall; external 'spssio32.dll' name 'spssCloseRead@4'; 

  function spssFreevarnames(var varnames: char; var varTypes: Integer; numVars: Integer):integer;   stdcall; external 'spssio32.dll' name 'returned by';

//   function spssFreeVarCValueLabels( * values:pchar; ** labels:pchar; var numLabels:Integer ) :integer;   stdcall; external 'spssio32.dll' name 'spssFreeVarCValueLabels@12';    // Error :

//   function spssFreeVarNValueLabels(var values: double;* labels:pchar; var numLabels:Integer  ) :integer;   stdcall; external 'spssio32.dll' name 'spssFreeVarNValueLabels@16';    // Error :

  function spssOpenAppend(const filename : Pchar; var handle: Integer):integer;   stdcall; external 'spssio32.dll' name 'spssOpenAppend@8'; 

  function spssCloseAppend(const handle: Integer):integer;   stdcall; external 'spssio32.dll' name 'spssCloseAppend@4'; 

  function spssGetSystemString(const handle: Integer; var sysname : idtype):integer;   stdcall; external 'spssio32.dll' name 'spssGetSystemString@8';

  function spssGetTimeStamp(const handle: Integer; var fileDate: vartype; var fileTime: vartype):integer;   stdcall; external 'spssio32.dll' name 'spssGetTimeStamp@12'; 

  function spssGetVarLabelLong(const handle: Integer; const varname : Pchar; var labelBuff: char; 
	 const lenBuff: Integer; var lenLabel: Integer):integer;   stdcall; external 'spssio32.dll' name 'spssGetVarLabelLong@20'; 

  function spssGetVarNValueLabelLong(const handle: Integer; const varname : Pchar; 
	 const value: double; var labelBuff: char; const lenBuff: Integer; var lenLabel: Integer):integer;   stdcall; external 'spssio32.dll' name 'spssGetVarNValueLabelLong@28'; 

  function spssGetVarCValueLabelLong(const handle: Integer; const varname : Pchar; 
	 const value: Pchar; var labelBuff: char; const lenBuff: Integer; var lenLabel: Integer):integer;   stdcall; external 'spssio32.dll' name 'spssGetVarCValueLabelLong@24'; 

  function spssSeekNextCase(const handle: Integer; const caseNumber: LongInt):integer;   stdcall; external 'spssio32.dll' name 'spssSeekNextCase@8'; 

  function spssGetEstimatedNofCases(const handle: Integer; var caseCount: LongInt):integer;   stdcall; external 'spssio32.dll' name 'spssGetEstimatedNofCases@8'; 

  function spssFreeVariableSets(var varSets: char):integer;   stdcall; external 'spssio32.dll' name 'spssFreeVariableSets@4'; 

  function spssFreeDateVariables(var dateInfo: LongInt):integer;   stdcall; external 'spssio32.dll' name 'spssFreeDateVariables@4';
//*********************************

 function errorcode(error:integer):string;
 procedure filecheck;



const
  maxV =600;
var
  fh,error:integer;
  filename:string;
  numV,nCases:longint;
  id:idtype;
  compSwitch:integer;
  caseWeight:vartype;
//  nameV:vartype;
  nameV:array[0..maxV] of vartype;
  snameV:string;
  typesV:array[0..maxV] of integer;
  typesVF:array[0..maxV] of integer;
  typeV:integer;
  typeVF,dec,wid:integer;
  VF:array[0..maxV] of string;
  VWriteF:array[0..(maxV-1)] of string;
  VWide:array[0..(maxV-1)] of integer;
  vLabel:varLabeltype;
  svLabel:string;
  valLabel:valueLabeltype;
  svarLabel:string;
  nvalue:double;
  handlesV:array[0..maxV] of double;
  casesPrint:longint;
  cValue:charValuetype;
  scValue:string;
  sysmis:double;
  iV:integer;
  WhereComeFrom:string;


implementation

//G[R[h𕶎ɕϊ
function errorcode(error:integer):string;
begin
// ***************************************** ERROR CODES
if  error=SPSS_OK then errorcode:='SPSS_OK';
if  error=SPSS_FILE_OERROR then errorcode:='SPSS_FILE_OERROR';
if  error=SPSS_FILE_WERROR  then errorcode:='SPSS_FILE_WERROR';

if  error=SPSS_FILE_RERROR  then errorcode:='SPSS_FILE_RERROR';
if  error=SPSS_FITAB_FULL  then errorcode:='SPSS_FITAB_FULL';
if  error=SPSS_INVALID_HANDLE  then errorcode:='SPSS_INVALID_HANDLE';
if  error=SPSS_INVALID_FILE  then errorcode:='SPSS_INVALID_FILE';
if  error=SPSS_NO_MEMORY  then errorcode:='SPSS_NO_MEMORY';
if  error=SPSS_OPEN_RDMODE  then errorcode:='SPSS_OPEN_RDMODE';
if  error=SPSS_OPEN_WRMODE  then errorcode:='SPSS_OPEN_WRMODE';

if  error=SPSS_INVALID_VARNAME  then errorcode:='SPSS_INVALID_VARNAME';
if  error=SPSS_DICT_EMPTY  then errorcode:='SPSS_DICT_EMPTY';
if  error=SPSS_VAR_NOTFOUND  then errorcode:='SPSS_VAR_NOTFOUND';
if  error=SPSS_DUP_VAR  then errorcode:='SPSS_DUP_VAR';
if  error=SPSS_NUME_EXP  then errorcode:='SPSS_NUME_EXP';
if  error=SPSS_STR_EXP  then errorcode:='SPSS_STR_EXP';
if  error=SPSS_SHORTSTR_EXP  then errorcode:='SPSS_SHORTSTR_EXP';
if  error=SPSS_INVALID_VARTYPE  then errorcode:='SPSS_INVALID_VARTYPE';

if  error=SPSS_INVALID_MISSFOR  then errorcode:='SPSS_INVALID_MISSFOR';
if  error=SPSS_INVALID_COMPSW  then errorcode:='SPSS_INVALID_COMPSW';
if  error=SPSS_INVALID_PRFOR  then errorcode:='SPSS_INVALID_PRFOR';
if  error=SPSS_INVALID_WRFOR  then errorcode:='SPSS_INVALID_WRFOR';
if  error=SPSS_INVALID_DATE  then errorcode:='SPSS_INVALID_DATE';
if  error=SPSS_INVALID_TIME  then errorcode:='SPSS_INVALID_TIME';

if  error=SPSS_NO_VARIABLES  then errorcode:='SPSS_NO_VARIABLES';
if  error=SPSS_DUP_VALUE  then errorcode:='SPSS_DUP_VALUE';

if  error=SPSS_INVALID_CASEWGT  then errorcode:='SPSS_INVALID_CASEWGT';
if  error=SPSS_DICT_COMMIT  then errorcode:='SPSS_DICT_COMMIT';
if  error=SPSS_DICT_NOTCOMMIT  then errorcode:='SPSS_DICT_NOTCOMMIT';

if  error=SPSS_NO_TYPE2  then errorcode:='SPSS_NO_TYPE2';
if  error=SPSS_NO_TYPE73  then errorcode:='SPSS_NO_TYPE73';
if  error=SPSS_INVALID_DATEINFO  then errorcode:='SPSS_INVALID_DATEINFO';
if  error=SPSS_NO_TYPE999  then errorcode:='SPSS_NO_TYPE999';
if  error=SPSS_EXC_STRVALUE  then errorcode:='SPSS_EXC_STRVALUE';
if  error=SPSS_CANNOT_FREE  then errorcode:='SPSS_CANNOT_FREE';
if  error=SPSS_BUFFER_SHORT  then errorcode:='SPSS_BUFFER_SHORT';
if  error=SPSS_INVALID_CASE  then errorcode:='SPSS_INVALID_CASE';
if  error=SPSS_INTERNAL_VLABS  then errorcode:='SPSS_INTERNAL_VLABS';
if  error=SPSS_INCOMPAT_APPEND  then errorcode:='SPSS_INCOMPAT_APPEND';
if  error=SPSS_INTERNAL_D_A  then errorcode:='SPSS_INTERNAL_D_A';
//***************************************** WARNING CODES
if  error=SPSS_EXC_LEN64  then errorcode:='warning:SPSS_EXC_LEN64';
if  error=SPSS_EXC_LEN120  then errorcode:='warning:SPSS_EXC_LEN120';
if  error=SPSS_EXC_VARLABEL  then errorcode:='warning:SPSS_EXC_VARLABEL';
if  error=SPSS_EXC_LEN60  then errorcode:='warning:SPSS_EXC_LEN60';
if  error=SPSS_EXC_VALLABEL  then errorcode:='warning:SPSS_EXC_VALLABEL';
if  error=SPSS_FILE_END  then errorcode:='warning:SPSS_FILE_END';
if  error=SPSS_NO_VARSETS  then errorcode:='warning:SPSS_NO_VARSETS';
if  error=SPSS_EMPTY_VARSETS  then errorcode:='warning:SPSS_EMPTY_VARSETS';
if  error=SPSS_NO_LABELS  then errorcode:='warning:SPSS_NO_LABELS';
if  error=SPSS_NO_LABEL  then errorcode:='warning:SPSS_NO_LABEL';
if  error=SPSS_NO_CASEWGT  then errorcode:='warning:SPSS_NO_CASEWGT';
if  error=SPSS_NO_DATEINFO  then errorcode:='warning:SPSS_NO_DATEINFO';
end;

//rorrf[^t@Ĉ`FbN
procedure filecheck;
begin
  if filename='' then exit;
  error:=spssOpenRead(pchar(filename),fh);
  if error<>0 then begin
    showmessage('file accesss');
  end;
end;


end.
